import{s as dt,f as gt,o as vt}from"../chunks/scheduler.7bc62968.js";import{S as $t,i as bt,g as l,s as n,r as u,A as wt,h as r,f as i,c as s,j as Ue,u as c,x as o,k as m,y as Tt,a,v as h,d as p,t as g,w as d,m as Ct,n as xt}from"../chunks/index.2f8492b0.js";import{T as yt}from"../chunks/Tip.016f38d9.js";import{H as w,E as _t}from"../chunks/index.71444864.js";function Vt(ie){let f;return{c(){f=Ct(`However, in most scenarios, applying transfer learning is ample in the case of
  Vision Transformers.`)},l(v){f=xt(v,`However, in most scenarios, applying transfer learning is ample in the case of
  Vision Transformers.`)},m(v,y){a(v,f,y)},d(v){v&&i(f)}}}function Pt(ie){let f,v,y,ae,_,ne,V,se,P,Oe="As the Transformers architecture scaled well in Natural Language Processing, the same architecture was applied to images by creating small patches of the image and treating them as tokens. The result was a Vision Transformer (ViT). Before we get started with transfer learning / fine-tuning concepts, let’s compare Convolutional Neural Networks (CNNs) with Vision Transformers.",le,H,re,I,Ye="To summarize, in Vision transformer, images are reorganized as 2D grids of patches. The models are trained on those patches.",oe,L,De=`The main idea can be found at the picture below:
<img src="https://huggingface.co/datasets/hf-vision/course-assets/blob/main/Screenshot%20from%202024-12-27%2014-25-49.png" alt="Vision Transformer"/>`,fe,M,Ge="But there is a catch! The Convolutional Neural Networks (CNN)  are designed with an assumption missing in the VT. This assumption is based on how we perceive the objects in the images as humans. It is described in the following section.",me,N,ue,k,ce,A,Je="Inductive bias is a term used in machine learning to describe the set of assumptions that a learning algorithm uses to make predictions. In simpler terms, inductive bias is like a shortcut that helps a machine learning model make educated guesses based on the information it has seen so far.",he,z,Ke="Here’s a couple of inductive biases we observe in CNNs:",pe,E,Qe="<li>Translational Equivariance: an object can appear anywhere in the image, and CNNs can detect its features.</li> <li>Locality: pixels in an image interact mainly with its surrounding pixels to form features.</li>",ge,S,Xe=`CNN models are very good at these two biases. ViT do not have this assumption. That is why for a dataset size up to a certain threshold actually CNNs are better than ViT. But ViT has another power!
The transformer architecture being (mostly) different types of linear functions allows ViT to become highly scalable. And that in turn allows ViT to overcome the problem of not having the above two
inductive biases with massive ammount of data!`,de,R,ve,B,Ze='It’s not feasible for everyone to train a Vision Transformer on millions of images to get good performance. Instead, one can use openly available model weights from places such as the <a href="https://huggingface.co/models?sort=trending" rel="nofollow">Hugging Face Hub</a>.',$e,F,et="What do you do with the pre-trained model? You can apply transfer learning and fine-tune it!",be,W,we,j,tt="The idea of transfer learning is that we can leverage the features learned by the Vision Transformers trained on a very large dataset and apply these features to our dataset. This can lead to significant improvements in model performance, especially when our dataset has limited data available for training.",Te,q,it="Since we are taking advantage of the learned features, we do not need to update the entire model either. By freezing most of the weights, we can train only certain layers to get excellent performance with less training time and low GPU consumption.",Ce,U,xe,O,at="You can go through the transfer learning tutorial using Vision Transformers for image classification in this notebook:",ye,T,nt='<img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/>',_e,Y,st="This is what we’ll be building: an image classifier to tell apart dog and cat breeds:",Ve,$,lt,Pe,He,Ie,D,rt="It might be that the domain of your dataset is not very similar to the pre-trained model’s dataset. Yet, instead of training a Vision Transformer from scratch, we can choose to update the weights of the entire pre-trained model albeit with a lower learning rate, which will “fine-tune” the model to perform well with our data.",Le,x,Me,G,Ne,J,ot="The tutorial above teaches multi-class image classification, where each image only has 1 class assigned to it. What about scenarios where each image has multiple labels in a multi-class dataset?",ke,K,ft="This notebook will walk you through a fine-tuning tutorial using Vision Transformer for multi-label image classification:",Ae,C,mt='<img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/>',ze,Q,ut=`We’ll also be learning how to use <a href="https://huggingface.co/docs/accelerate/index" rel="nofollow">Hugging Face Accelerate</a> to write our custom training loops.
This is what you can expect to see as the outcome of the multi-label classification tutorial:`,Ee,b,ct,Se,Re,Be,X,Fe,Z,ht='<li>Original Vision Transformers Paper: <em>An Image is Worth 16x16 Words: Transformers for Image Recognition at Scale <a href="https://huggingface.co/papers/2010.11929" rel="nofollow">Paper</a></em></li> <li>Swin Transformers Paper: <em>Swin Transformer: Hierarchical Vision Transformer using Shifted Windows <a href="https://huggingface.co/papers/2103.14030" rel="nofollow">Paper</a></em></li> <li>A systematic empirical study in order to better understand the interplay between the amount of training data, regularization, augmentation, model size and compute budget for Vision Transformers: <em>How to train your Vision Transformers? Data, Augmentation, and Regularization in Vision Transformers <a href="https://huggingface.co/papers/2106.10270" rel="nofollow">Paper</a></em></li>',We,ee,je,te,qe;return _=new w({props:{title:"Transfer Learning and Fine-tuning Vision Transformers for Image Classification",local:"transfer-learning-and-fine-tuning-vision-transformers-for-image-classification",headingTag:"h1"}}),V=new w({props:{title:"Introduction",local:"introduction",headingTag:"h2"}}),H=new w({props:{title:"Vision Transformer (VT) a Summary",local:"vision-transformer-vt-a-summary",headingTag:"h2"}}),N=new w({props:{title:"What are the differences between CNNs and Vision Transformers?",local:"what-are-the-differences-between-cnns-and-vision-transformers",headingTag:"h2"}}),k=new w({props:{title:"Inductive Bias",local:"inductive-bias",headingTag:"h3"}}),R=new w({props:{title:"But how can everyone get access to massive datasets?",local:"but-how-can-everyone-get-access-to-massive-datasets",headingTag:"h3"}}),W=new w({props:{title:"Transfer Learning & Fine-Tuning for Image Classification",local:"transfer-learning--fine-tuning-for-image-classification",headingTag:"h2"}}),U=new w({props:{title:"Multi-class Image Classification",local:"multi-class-image-classification",headingTag:"h3"}}),x=new yt({props:{$$slots:{default:[Vt]},$$scope:{ctx:ie}}}),G=new w({props:{title:"Multi-label Image Classification",local:"multi-label-image-classification",headingTag:"h3"}}),X=new w({props:{title:"Additional Resources",local:"additional-resources",headingTag:"h3"}}),ee=new _t({props:{source:"https://github.com/huggingface/computer-vision-course/blob/main/chapters/en/unit3/vision-transformers/vision-transformers-for-image-classification.mdx"}}),{c(){f=l("meta"),v=n(),y=l("p"),ae=n(),u(_.$$.fragment),ne=n(),u(V.$$.fragment),se=n(),P=l("p"),P.textContent=Oe,le=n(),u(H.$$.fragment),re=n(),I=l("p"),I.textContent=Ye,oe=n(),L=l("p"),L.innerHTML=De,fe=n(),M=l("p"),M.textContent=Ge,me=n(),u(N.$$.fragment),ue=n(),u(k.$$.fragment),ce=n(),A=l("p"),A.textContent=Je,he=n(),z=l("p"),z.textContent=Ke,pe=n(),E=l("ul"),E.innerHTML=Qe,ge=n(),S=l("p"),S.textContent=Xe,de=n(),u(R.$$.fragment),ve=n(),B=l("p"),B.innerHTML=Ze,$e=n(),F=l("p"),F.textContent=et,be=n(),u(W.$$.fragment),we=n(),j=l("p"),j.textContent=tt,Te=n(),q=l("p"),q.textContent=it,Ce=n(),u(U.$$.fragment),xe=n(),O=l("p"),O.textContent=at,ye=n(),T=l("a"),T.innerHTML=nt,_e=n(),Y=l("p"),Y.textContent=st,Ve=n(),$=l("iframe"),Pe=n(),He=l("hr"),Ie=n(),D=l("p"),D.textContent=rt,Le=n(),u(x.$$.fragment),Me=n(),u(G.$$.fragment),Ne=n(),J=l("p"),J.textContent=ot,ke=n(),K=l("p"),K.textContent=ft,Ae=n(),C=l("a"),C.innerHTML=mt,ze=n(),Q=l("p"),Q.innerHTML=ut,Ee=n(),b=l("iframe"),Se=n(),Re=l("hr"),Be=n(),u(X.$$.fragment),Fe=n(),Z=l("ul"),Z.innerHTML=ht,We=n(),u(ee.$$.fragment),je=n(),te=l("p"),this.h()},l(e){const t=wt("svelte-u9bgzb",document.head);f=r(t,"META",{name:!0,content:!0}),t.forEach(i),v=s(e),y=r(e,"P",{}),Ue(y).forEach(i),ae=s(e),c(_.$$.fragment,e),ne=s(e),c(V.$$.fragment,e),se=s(e),P=r(e,"P",{"data-svelte-h":!0}),o(P)!=="svelte-12df8ov"&&(P.textContent=Oe),le=s(e),c(H.$$.fragment,e),re=s(e),I=r(e,"P",{"data-svelte-h":!0}),o(I)!=="svelte-48lmsw"&&(I.textContent=Ye),oe=s(e),L=r(e,"P",{"data-svelte-h":!0}),o(L)!=="svelte-1qffh2j"&&(L.innerHTML=De),fe=s(e),M=r(e,"P",{"data-svelte-h":!0}),o(M)!=="svelte-vjga52"&&(M.textContent=Ge),me=s(e),c(N.$$.fragment,e),ue=s(e),c(k.$$.fragment,e),ce=s(e),A=r(e,"P",{"data-svelte-h":!0}),o(A)!=="svelte-1dalnic"&&(A.textContent=Je),he=s(e),z=r(e,"P",{"data-svelte-h":!0}),o(z)!=="svelte-10dh0kb"&&(z.textContent=Ke),pe=s(e),E=r(e,"UL",{"data-svelte-h":!0}),o(E)!=="svelte-2rnodl"&&(E.innerHTML=Qe),ge=s(e),S=r(e,"P",{"data-svelte-h":!0}),o(S)!=="svelte-1bsqcb0"&&(S.textContent=Xe),de=s(e),c(R.$$.fragment,e),ve=s(e),B=r(e,"P",{"data-svelte-h":!0}),o(B)!=="svelte-a2ize3"&&(B.innerHTML=Ze),$e=s(e),F=r(e,"P",{"data-svelte-h":!0}),o(F)!=="svelte-tzzmmr"&&(F.textContent=et),be=s(e),c(W.$$.fragment,e),we=s(e),j=r(e,"P",{"data-svelte-h":!0}),o(j)!=="svelte-lv9oxx"&&(j.textContent=tt),Te=s(e),q=r(e,"P",{"data-svelte-h":!0}),o(q)!=="svelte-wd6g65"&&(q.textContent=it),Ce=s(e),c(U.$$.fragment,e),xe=s(e),O=r(e,"P",{"data-svelte-h":!0}),o(O)!=="svelte-kq6390"&&(O.textContent=at),ye=s(e),T=r(e,"A",{target:!0,href:!0,"data-svelte-h":!0}),o(T)!=="svelte-12g8xd0"&&(T.innerHTML=nt),_e=s(e),Y=r(e,"P",{"data-svelte-h":!0}),o(Y)!=="svelte-110b06h"&&(Y.textContent=st),Ve=s(e),$=r(e,"IFRAME",{src:!0,frameborder:!0,width:!0,height:!0}),Ue($).forEach(i),Pe=s(e),He=r(e,"HR",{}),Ie=s(e),D=r(e,"P",{"data-svelte-h":!0}),o(D)!=="svelte-tvstd8"&&(D.textContent=rt),Le=s(e),c(x.$$.fragment,e),Me=s(e),c(G.$$.fragment,e),Ne=s(e),J=r(e,"P",{"data-svelte-h":!0}),o(J)!=="svelte-13genqx"&&(J.textContent=ot),ke=s(e),K=r(e,"P",{"data-svelte-h":!0}),o(K)!=="svelte-1cp2nc"&&(K.textContent=ft),Ae=s(e),C=r(e,"A",{target:!0,href:!0,"data-svelte-h":!0}),o(C)!=="svelte-16dmzty"&&(C.innerHTML=mt),ze=s(e),Q=r(e,"P",{"data-svelte-h":!0}),o(Q)!=="svelte-106nsty"&&(Q.innerHTML=ut),Ee=s(e),b=r(e,"IFRAME",{src:!0,frameborder:!0,width:!0,height:!0}),Ue(b).forEach(i),Se=s(e),Re=r(e,"HR",{}),Be=s(e),c(X.$$.fragment,e),Fe=s(e),Z=r(e,"UL",{"data-svelte-h":!0}),o(Z)!=="svelte-no67uu"&&(Z.innerHTML=ht),We=s(e),c(ee.$$.fragment,e),je=s(e),te=r(e,"P",{}),Ue(te).forEach(i),this.h()},h(){m(f,"name","hf:doc:metadata"),m(f,"content",Ht),m(T,"target","_blank"),m(T,"href","https://colab.research.google.com/github/johko/computer-vision-course/blob/main/notebooks/Unit%203%20-%20Vision%20Transformers/transfer-learning-image-classification.ipynb"),gt($.src,lt="https://shreydan-oxford-iiit-pets-classifier.hf.space")||m($,"src",lt),m($,"frameborder","0"),m($,"width","850"),m($,"height","450"),m(C,"target","_blank"),m(C,"href","https://colab.research.google.com/github/johko/computer-vision-course/blob/main/notebooks/Unit%203%20-%20Vision%20Transformers/fine-tuning-multilabel-image-classification.ipynb"),gt(b.src,ct="https://shreydan-pascal-multilabel-classifier.hf.space")||m(b,"src",ct),m(b,"frameborder","0"),m(b,"width","850"),m(b,"height","450")},m(e,t){Tt(document.head,f),a(e,v,t),a(e,y,t),a(e,ae,t),h(_,e,t),a(e,ne,t),h(V,e,t),a(e,se,t),a(e,P,t),a(e,le,t),h(H,e,t),a(e,re,t),a(e,I,t),a(e,oe,t),a(e,L,t),a(e,fe,t),a(e,M,t),a(e,me,t),h(N,e,t),a(e,ue,t),h(k,e,t),a(e,ce,t),a(e,A,t),a(e,he,t),a(e,z,t),a(e,pe,t),a(e,E,t),a(e,ge,t),a(e,S,t),a(e,de,t),h(R,e,t),a(e,ve,t),a(e,B,t),a(e,$e,t),a(e,F,t),a(e,be,t),h(W,e,t),a(e,we,t),a(e,j,t),a(e,Te,t),a(e,q,t),a(e,Ce,t),h(U,e,t),a(e,xe,t),a(e,O,t),a(e,ye,t),a(e,T,t),a(e,_e,t),a(e,Y,t),a(e,Ve,t),a(e,$,t),a(e,Pe,t),a(e,He,t),a(e,Ie,t),a(e,D,t),a(e,Le,t),h(x,e,t),a(e,Me,t),h(G,e,t),a(e,Ne,t),a(e,J,t),a(e,ke,t),a(e,K,t),a(e,Ae,t),a(e,C,t),a(e,ze,t),a(e,Q,t),a(e,Ee,t),a(e,b,t),a(e,Se,t),a(e,Re,t),a(e,Be,t),h(X,e,t),a(e,Fe,t),a(e,Z,t),a(e,We,t),h(ee,e,t),a(e,je,t),a(e,te,t),qe=!0},p(e,[t]){const pt={};t&2&&(pt.$$scope={dirty:t,ctx:e}),x.$set(pt)},i(e){qe||(p(_.$$.fragment,e),p(V.$$.fragment,e),p(H.$$.fragment,e),p(N.$$.fragment,e),p(k.$$.fragment,e),p(R.$$.fragment,e),p(W.$$.fragment,e),p(U.$$.fragment,e),p(x.$$.fragment,e),p(G.$$.fragment,e),p(X.$$.fragment,e),p(ee.$$.fragment,e),qe=!0)},o(e){g(_.$$.fragment,e),g(V.$$.fragment,e),g(H.$$.fragment,e),g(N.$$.fragment,e),g(k.$$.fragment,e),g(R.$$.fragment,e),g(W.$$.fragment,e),g(U.$$.fragment,e),g(x.$$.fragment,e),g(G.$$.fragment,e),g(X.$$.fragment,e),g(ee.$$.fragment,e),qe=!1},d(e){e&&(i(v),i(y),i(ae),i(ne),i(se),i(P),i(le),i(re),i(I),i(oe),i(L),i(fe),i(M),i(me),i(ue),i(ce),i(A),i(he),i(z),i(pe),i(E),i(ge),i(S),i(de),i(ve),i(B),i($e),i(F),i(be),i(we),i(j),i(Te),i(q),i(Ce),i(xe),i(O),i(ye),i(T),i(_e),i(Y),i(Ve),i($),i(Pe),i(He),i(Ie),i(D),i(Le),i(Me),i(Ne),i(J),i(ke),i(K),i(Ae),i(C),i(ze),i(Q),i(Ee),i(b),i(Se),i(Re),i(Be),i(Fe),i(Z),i(We),i(je),i(te)),i(f),d(_,e),d(V,e),d(H,e),d(N,e),d(k,e),d(R,e),d(W,e),d(U,e),d(x,e),d(G,e),d(X,e),d(ee,e)}}}const Ht='{"title":"Transfer Learning and Fine-tuning Vision Transformers for Image Classification","local":"transfer-learning-and-fine-tuning-vision-transformers-for-image-classification","sections":[{"title":"Introduction","local":"introduction","sections":[],"depth":2},{"title":"Vision Transformer (VT) a Summary","local":"vision-transformer-vt-a-summary","sections":[],"depth":2},{"title":"What are the differences between CNNs and Vision Transformers?","local":"what-are-the-differences-between-cnns-and-vision-transformers","sections":[{"title":"Inductive Bias","local":"inductive-bias","sections":[],"depth":3},{"title":"But how can everyone get access to massive datasets?","local":"but-how-can-everyone-get-access-to-massive-datasets","sections":[],"depth":3}],"depth":2},{"title":"Transfer Learning & Fine-Tuning for Image Classification","local":"transfer-learning--fine-tuning-for-image-classification","sections":[{"title":"Multi-class Image Classification","local":"multi-class-image-classification","sections":[],"depth":3},{"title":"Multi-label Image Classification","local":"multi-label-image-classification","sections":[],"depth":3},{"title":"Additional Resources","local":"additional-resources","sections":[],"depth":3}],"depth":2}],"depth":1}';function It(ie){return vt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class At extends $t{constructor(f){super(),bt(this,f,It,Pt,dt,{})}}export{At as component};
