import{s as Ue,n as Fe,o as Ke}from"../chunks/scheduler.7bc62968.js";import{S as Xe,i as Je,g as l,s,r as d,A as Qe,h as r,f as i,c as a,j as Oe,u as m,x as o,k as y,y as We,a as n,v as p,d as u,t as f,w as v}from"../chunks/index.2f8492b0.js";import{H as c,E as Ye}from"../chunks/index.71444864.js";function Ze(de){let h,ft,pt,vt,D,ct,M,ht,L,me="The success of Deep Learning, particularly CNNs trained on massive datasets like ImageNet, revolutionized image recognition. This trend continues in video processing. However, video data introduces another dimension compared to static images: time. This simple change introduced a new set of challenges that CNNs trained in static images were not built to deal with.",gt,b,Tt,N,$t,g,pe='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/previous sota models/SOTA Models Two-Stream architecture for video classification.png" alt="Two-Stream architecture for video classification"/>',wt,H,ue="This paper extended Deep Convolutional Networks(ConvNets) to perform action-recognition in video data.",Ct,_,fe="The proposed architecture is called Two-Stream Network. It uses two separate pathways within a neural network:",xt,k,ve="<li><strong>Spatial Stream:</strong> A standard 2D CNN processes individual frames to capture appearance information.</li> <li><strong>Temporal Stream:</strong> A 2D CNN, or another network, that processes several frame sequences (optical flow) to capture motion information.</li> <li><strong>Fusion:</strong> The outputs from both streams are then combined to leverage both appearance and motion cues for tasks like action recognition.</li>",yt,S,Dt,T,ce='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/previous sota models/SOTA Models Residual block. Shortcut connections bypass a signal from the top of the block to the tail. Signals are summed at the tail..png" alt="Residual block. Shortcut connections bypass a signal from the top of the block to the tail. Signals are summed at the tail."/>',Mt,P,he="Standard 3D CNNs extend the concept to simultaneously capture spatial and temporal information using 3D kernels (2D spatial information + temporal information). A drawback of this model is that the large number of parameters result in the training being more computationally intensive and hence slower than the 2D version. Therefore, the 3D version of the ConvNets typically has fewer layers than the deeper architectures of 2D CNNs.",Lt,R,ge="In this paper, the authors applied the ResNet architecture to the 3D CNNs. This approach introduces deeper models for 3D CNNs and achieves higher accuracy.",bt,A,Te='Experiments showed that the 3D ResNets (especially deeper ones like the ResNet-34) outperform models like the <a href="https://arxiv.org/abs/1412.0767" rel="nofollow">C3D</a>, particularly on larger datasets. Pretrained models like Sports-1M C3D can help mitigate overfitting on smaller datasets. Overall, 3D ResNets effectively leverage deeper architectures to capture complex spatiotemporal patterns in the video data.',Nt,E,$e="<thead><tr><th>Method</th> <th>Validation set</th> <th></th> <th></th> <th>Testing set</th> <th></th> <th></th></tr></thead> <tbody><tr><td></td> <td>Top-1</td> <td>Top-5</td> <td>Average</td> <td>Top-1</td> <td>Top-5</td> <td>Average</td></tr> <tr><td>3D ResNet-34</td> <td>58.0</td> <td>81.3</td> <td><strong>69.7</strong></td> <td>-</td> <td>-</td> <td><strong>68.9</strong></td></tr> <tr><td>C3D*</td> <td>55.6</td> <td>79.1</td> <td>67.4</td> <td>56.1</td> <td>79.5</td> <td>67.8</td></tr> <tr><td>C3D w/ BN</td> <td>56.1</td> <td>79.5</td> <td>67.8</td> <td>-</td> <td>-</td> <td>-</td></tr> <tr><td>RGB-I3D w/o ImageNet</td> <td>-</td> <td>-</td> <td>68.4</td> <td>88.0</td> <td><strong>78.2</strong></td> <td></td></tr></tbody>",Ht,V,_t,$,we='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/previous sota models/SOTA Models 3D vs (2+1)D convolution..png" alt="3D vs (2+1)D convolution."/>',kt,I,Ce="(2+1)D ResNets are inspired by the 3D ResNets. However, a key difference lies in how the layers are structured. This architecture introduces a combination of 2D convolution and 1D convolution:",St,j,xe="<li>The 2D convolution captures the spatial features within a frame.</li> <li>The 1D convolution captures the motion information across the consecutive frames.</li>",Pt,z,ye="This model can learn spatiotemporal features directly from video data, potentially leading to better performance in video analysis tasks like action recognition.",Rt,q,De="<li>Benefits:<ul><li>The addition of nonlinear rectification (ReLU) between two operations doubles the number of non-linearities compared to a network using full 3D convolution for the same number of parameters, thus rendering the model capable of representing more complex functions.</li> <li>Decomposition facilitates the optimization, yielding in lower train loss and test loss in practice.</li></ul></li>",At,B,Me="<thead><tr><th>Method</th> <th>Clip@1 Accuracy</th> <th>Video@1 Accuracy</th> <th>Video@5 Accuracy</th></tr></thead> <tbody><tr><td>DeepVideo</td> <td>41.9</td> <td>60.9</td> <td>80.2</td></tr> <tr><td>C3D</td> <td>46.1</td> <td>61.1</td> <td>85.2</td></tr> <tr><td>2D ResNet-152</td> <td>46.5</td> <td>64.6</td> <td>86.4</td></tr> <tr><td>Conv pooling</td> <td>-</td> <td>71.7</td> <td>90.4</td></tr> <tr><td>P3D</td> <td>47.9</td> <td>66.4</td> <td>87.4</td></tr> <tr><td>R3D-RGB-8frame</td> <td>53.8</td> <td>-</td> <td>-</td></tr> <tr><td>R(2+1)D-RGB-8frame</td> <td>56.1</td> <td>72.0</td> <td>91.2</td></tr> <tr><td>R(2+1)D-Flow-8frame</td> <td>44.5</td> <td>65.5</td> <td>87.2</td></tr> <tr><td>R(2+1)D-Two-Stream-8frame</td> <td>-</td> <td>72.2</td> <td>91.4</td></tr> <tr><td>R(2+1)D-RGB-32frame</td> <td><strong>57.0</strong></td> <td><strong>73.0</strong></td> <td><strong>91.5</strong></td></tr> <tr><td>R(2+1)D-Flow-32frame</td> <td>46.4</td> <td>68.4</td> <td>88.7</td></tr> <tr><td>R(2+1)D-Two-Stream-32frame</td> <td>-</td> <td><strong>73.3</strong></td> <td><strong>91.9</strong></td></tr></tbody>",Et,G,Vt,O,Le=`Currently, researchers are exploring deeper 3D CNN architectures. Another promising approach is combining 3D CNNs with other techniques like attention mechanisms. Alongside that, there is a push for developing larger video datasets like <a href="https://github.com/google-deepmind/kinetics-i3d" rel="nofollow">Kinetics</a>.
The Kinetics dataset is a large-scale high-quality video dataset commonly used for human action recognition research. It contains hundreds of thousands of video clips that cover a wide range of human activities.`,It,U,jt,F,zt,w,be='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/unit7 CNN based model/Self-Supervised Learning_MoCo.png" alt="3D vs (2+1)D convolution."/>',qt,K,Ne="<strong>Overview</strong>",Bt,X,He='<a href="https://arxiv.org/abs/1911.05722" rel="nofollow">MoCo</a> is a prominent model in the Self-Supervised Learning domain, using a contrastive learning approach to extract features from unlabeled video clips. By utilizing a momentum-based queue, it effectively learns from large-scale video datasets, making it ideal for tasks such as action recognition and event detection.',Gt,J,_e="<strong>Key Features</strong>",Ot,Q,ke="<li><strong>Momentum Encoder</strong>: Uses a momentum-updated encoder to maintain consistency in the representation space, enhancing training stability.</li> <li><strong>Dynamic Dictionary</strong>: Employs a queue-based dictionary that provides a large and consistent set of negative samples for contrastive learning.</li> <li><strong>Contrastive Loss Function</strong>: Leverages contrastive loss to learn invariant features by comparing positive and negative pairs.</li>",Ut,W,Ft,C,Se='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/unit7 CNN based model/Efficient Video Models X3D (Expanded 3D Networks).png" alt="3D vs (2+1)D convolution."/>',Kt,Y,Pe="<strong>Overview</strong>",Xt,Z,Re='<a href="https://arxiv.org/abs/2004.04730" rel="nofollow">X3D</a> is a lightweight 3D ConvNet model designed for video recognition tasks. It builds on the concept of 3D CNNs but optimizes for fewer parameters and lower computational cost while maintaining high performance. This makes it suitable for real-time video analysis and deployment on mobile or edge devices.',Jt,tt,Ae="<strong>Key Features</strong>",Qt,et,Ee="<li><strong>Efficiency</strong>: Achieves high accuracy with significantly fewer parameters and reduced computational cost.</li> <li><strong>Progressive Expansion</strong>: Utilizes a systematic approach to expand network dimensions (e.g., depth, width) for optimal performance.</li> <li><strong>Deployment-Friendly</strong>: Designed for easy deployment on devices with limited computational resources.</li>",Wt,it,Yt,x,Ve='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/unit7 CNN based model/Efficient Video Models X3D (Expanded 3D Networks).png" alt="3D vs (2+1)D convolution."/>',Zt,nt,Ie="<strong>Overview</strong>",te,st,je='<a href="https://arxiv.org/abs/1801.07455" rel="nofollow">ST-GCN</a> is a model tailored for real-time action recognition, particularly in analyzing human movements in video sequences. It models spatio-temporal data using a graph structure, effectively capturing human joint positions and movements. This model is widely used in applications like surveillance and sports analysis for real-time action detection.',ee,at,ze="These cutting-edge models are playing a crucial role in advancing video processing, excelling in areas such as video classification, action recognition, and real-time processing.",ie,lt,qe="<strong>Key Features</strong>",ne,rt,Be="<li><strong>Graph-Based Modeling</strong>: Represents human skeletal data as graphs, allowing for natural modeling of joint connections.</li> <li><strong>Spatio-Temporal Convolutions</strong>: Integrates spatial and temporal graph convolutions to capture dynamic movement patterns.</li> <li><strong>Real-Time Performance</strong>: Optimized for fast computation, making it suitable for real-time applications.</li>",se,ot,ae,dt,Ge="The evolution of video analysis models has been fascinating to witness. These models were heavily influenced by other SOTA models. For example, Two-StreamNets was motivated by the ConvNets and (2+1)D ResNets were inspired by the 3D ResNets. As the research progresses, one can expect even more advanced architectures and techniques to emerge in the future.",le,mt,re,ut,oe;return D=new c({props:{title:"CNN Based Video Models",local:"cnn-based-video-models",headingTag:"h1"}}),M=new c({props:{title:"General Trend:",local:"general-trend",headingTag:"h3"}}),b=new c({props:{title:"Previous SOTA Models in Video Processing",local:"previous-sota-models-in-video-processing",headingTag:"h1"}}),N=new c({props:{title:"Two-Stream Network(2014)",local:"two-stream-network2014",headingTag:"h2"}}),S=new c({props:{title:"3D ResNets(2017)",local:"3d-resnets2017",headingTag:"h2"}}),V=new c({props:{title:"(2+1)D ResNets(2017)",local:"21d-resnets2017",headingTag:"h2"}}),G=new c({props:{title:"Current Research",local:"current-research",headingTag:"h1"}}),U=new c({props:{title:"Current Research",local:"current-research",headingTag:"h1"}}),F=new c({props:{title:"Self-Supervised Learning: MoCo (Momentum Contrast)",local:"self-supervised-learning-moco-momentum-contrast",headingTag:"h3"}}),W=new c({props:{title:"Efficient Video Models: X3D (Expanded 3D Networks)",local:"efficient-video-models-x3d-expanded-3d-networks",headingTag:"h3"}}),it=new c({props:{title:"Real-time Video Processing: ST-GCN (Spatial-Temporal Graph Convolutional Networks)",local:"real-time-video-processing-st-gcn-spatial-temporal-graph-convolutional-networks",headingTag:"h3"}}),ot=new c({props:{title:"Conclusion",local:"conclusion",headingTag:"h1"}}),mt=new Ye({props:{source:"https://github.com/huggingface/computer-vision-course/blob/main/chapters/en/unit7/video-processing/cnn-based-video-model.mdx"}}),{c(){h=l("meta"),ft=s(),pt=l("p"),vt=s(),d(D.$$.fragment),ct=s(),d(M.$$.fragment),ht=s(),L=l("p"),L.textContent=me,gt=s(),d(b.$$.fragment),Tt=s(),d(N.$$.fragment),$t=s(),g=l("div"),g.innerHTML=pe,wt=s(),H=l("p"),H.textContent=ue,Ct=s(),_=l("p"),_.textContent=fe,xt=s(),k=l("ul"),k.innerHTML=ve,yt=s(),d(S.$$.fragment),Dt=s(),T=l("div"),T.innerHTML=ce,Mt=s(),P=l("p"),P.textContent=he,Lt=s(),R=l("p"),R.textContent=ge,bt=s(),A=l("p"),A.innerHTML=Te,Nt=s(),E=l("table"),E.innerHTML=$e,Ht=s(),d(V.$$.fragment),_t=s(),$=l("div"),$.innerHTML=we,kt=s(),I=l("p"),I.textContent=Ce,St=s(),j=l("ul"),j.innerHTML=xe,Pt=s(),z=l("p"),z.textContent=ye,Rt=s(),q=l("ul"),q.innerHTML=De,At=s(),B=l("table"),B.innerHTML=Me,Et=s(),d(G.$$.fragment),Vt=s(),O=l("p"),O.innerHTML=Le,It=s(),d(U.$$.fragment),jt=s(),d(F.$$.fragment),zt=s(),w=l("div"),w.innerHTML=be,qt=s(),K=l("p"),K.innerHTML=Ne,Bt=s(),X=l("p"),X.innerHTML=He,Gt=s(),J=l("p"),J.innerHTML=_e,Ot=s(),Q=l("ul"),Q.innerHTML=ke,Ut=s(),d(W.$$.fragment),Ft=s(),C=l("div"),C.innerHTML=Se,Kt=s(),Y=l("p"),Y.innerHTML=Pe,Xt=s(),Z=l("p"),Z.innerHTML=Re,Jt=s(),tt=l("p"),tt.innerHTML=Ae,Qt=s(),et=l("ul"),et.innerHTML=Ee,Wt=s(),d(it.$$.fragment),Yt=s(),x=l("div"),x.innerHTML=Ve,Zt=s(),nt=l("p"),nt.innerHTML=Ie,te=s(),st=l("p"),st.innerHTML=je,ee=s(),at=l("p"),at.textContent=ze,ie=s(),lt=l("p"),lt.innerHTML=qe,ne=s(),rt=l("ul"),rt.innerHTML=Be,se=s(),d(ot.$$.fragment),ae=s(),dt=l("p"),dt.textContent=Ge,le=s(),d(mt.$$.fragment),re=s(),ut=l("p"),this.h()},l(t){const e=Qe("svelte-u9bgzb",document.head);h=r(e,"META",{name:!0,content:!0}),e.forEach(i),ft=a(t),pt=r(t,"P",{}),Oe(pt).forEach(i),vt=a(t),m(D.$$.fragment,t),ct=a(t),m(M.$$.fragment,t),ht=a(t),L=r(t,"P",{"data-svelte-h":!0}),o(L)!=="svelte-1rkwn6u"&&(L.textContent=me),gt=a(t),m(b.$$.fragment,t),Tt=a(t),m(N.$$.fragment,t),$t=a(t),g=r(t,"DIV",{class:!0,"data-svelte-h":!0}),o(g)!=="svelte-mgjpl6"&&(g.innerHTML=pe),wt=a(t),H=r(t,"P",{"data-svelte-h":!0}),o(H)!=="svelte-1ad76us"&&(H.textContent=ue),Ct=a(t),_=r(t,"P",{"data-svelte-h":!0}),o(_)!=="svelte-dprwzq"&&(_.textContent=fe),xt=a(t),k=r(t,"UL",{"data-svelte-h":!0}),o(k)!=="svelte-1o607gt"&&(k.innerHTML=ve),yt=a(t),m(S.$$.fragment,t),Dt=a(t),T=r(t,"DIV",{class:!0,"data-svelte-h":!0}),o(T)!=="svelte-un2g90"&&(T.innerHTML=ce),Mt=a(t),P=r(t,"P",{"data-svelte-h":!0}),o(P)!=="svelte-o58140"&&(P.textContent=he),Lt=a(t),R=r(t,"P",{"data-svelte-h":!0}),o(R)!=="svelte-okfwgr"&&(R.textContent=ge),bt=a(t),A=r(t,"P",{"data-svelte-h":!0}),o(A)!=="svelte-1eszh10"&&(A.innerHTML=Te),Nt=a(t),E=r(t,"TABLE",{"data-svelte-h":!0}),o(E)!=="svelte-vd3gi2"&&(E.innerHTML=$e),Ht=a(t),m(V.$$.fragment,t),_t=a(t),$=r(t,"DIV",{class:!0,"data-svelte-h":!0}),o($)!=="svelte-3jw7no"&&($.innerHTML=we),kt=a(t),I=r(t,"P",{"data-svelte-h":!0}),o(I)!=="svelte-1ykrspd"&&(I.textContent=Ce),St=a(t),j=r(t,"UL",{"data-svelte-h":!0}),o(j)!=="svelte-1641fjx"&&(j.innerHTML=xe),Pt=a(t),z=r(t,"P",{"data-svelte-h":!0}),o(z)!=="svelte-zsre7z"&&(z.textContent=ye),Rt=a(t),q=r(t,"UL",{"data-svelte-h":!0}),o(q)!=="svelte-1xocyot"&&(q.innerHTML=De),At=a(t),B=r(t,"TABLE",{"data-svelte-h":!0}),o(B)!=="svelte-h1jeox"&&(B.innerHTML=Me),Et=a(t),m(G.$$.fragment,t),Vt=a(t),O=r(t,"P",{"data-svelte-h":!0}),o(O)!=="svelte-27hz17"&&(O.innerHTML=Le),It=a(t),m(U.$$.fragment,t),jt=a(t),m(F.$$.fragment,t),zt=a(t),w=r(t,"DIV",{class:!0,"data-svelte-h":!0}),o(w)!=="svelte-1610om4"&&(w.innerHTML=be),qt=a(t),K=r(t,"P",{"data-svelte-h":!0}),o(K)!=="svelte-9pdvmw"&&(K.innerHTML=Ne),Bt=a(t),X=r(t,"P",{"data-svelte-h":!0}),o(X)!=="svelte-ddqe35"&&(X.innerHTML=He),Gt=a(t),J=r(t,"P",{"data-svelte-h":!0}),o(J)!=="svelte-1i4nuav"&&(J.innerHTML=_e),Ot=a(t),Q=r(t,"UL",{"data-svelte-h":!0}),o(Q)!=="svelte-1jdd9qh"&&(Q.innerHTML=ke),Ut=a(t),m(W.$$.fragment,t),Ft=a(t),C=r(t,"DIV",{class:!0,"data-svelte-h":!0}),o(C)!=="svelte-u161mf"&&(C.innerHTML=Se),Kt=a(t),Y=r(t,"P",{"data-svelte-h":!0}),o(Y)!=="svelte-9pdvmw"&&(Y.innerHTML=Pe),Xt=a(t),Z=r(t,"P",{"data-svelte-h":!0}),o(Z)!=="svelte-1sworc4"&&(Z.innerHTML=Re),Jt=a(t),tt=r(t,"P",{"data-svelte-h":!0}),o(tt)!=="svelte-1i4nuav"&&(tt.innerHTML=Ae),Qt=a(t),et=r(t,"UL",{"data-svelte-h":!0}),o(et)!=="svelte-4p9xmb"&&(et.innerHTML=Ee),Wt=a(t),m(it.$$.fragment,t),Yt=a(t),x=r(t,"DIV",{class:!0,"data-svelte-h":!0}),o(x)!=="svelte-u161mf"&&(x.innerHTML=Ve),Zt=a(t),nt=r(t,"P",{"data-svelte-h":!0}),o(nt)!=="svelte-9pdvmw"&&(nt.innerHTML=Ie),te=a(t),st=r(t,"P",{"data-svelte-h":!0}),o(st)!=="svelte-1rg33dn"&&(st.innerHTML=je),ee=a(t),at=r(t,"P",{"data-svelte-h":!0}),o(at)!=="svelte-3m389y"&&(at.textContent=ze),ie=a(t),lt=r(t,"P",{"data-svelte-h":!0}),o(lt)!=="svelte-1i4nuav"&&(lt.innerHTML=qe),ne=a(t),rt=r(t,"UL",{"data-svelte-h":!0}),o(rt)!=="svelte-spi2cv"&&(rt.innerHTML=Be),se=a(t),m(ot.$$.fragment,t),ae=a(t),dt=r(t,"P",{"data-svelte-h":!0}),o(dt)!=="svelte-123m8qy"&&(dt.textContent=Ge),le=a(t),m(mt.$$.fragment,t),re=a(t),ut=r(t,"P",{}),Oe(ut).forEach(i),this.h()},h(){y(h,"name","hf:doc:metadata"),y(h,"content",ti),y(g,"class","flex justify-center"),y(T,"class","flex justify-center"),y($,"class","flex justify-center"),y(w,"class","flex justify-center"),y(C,"class","flex justify-center"),y(x,"class","flex justify-center")},m(t,e){We(document.head,h),n(t,ft,e),n(t,pt,e),n(t,vt,e),p(D,t,e),n(t,ct,e),p(M,t,e),n(t,ht,e),n(t,L,e),n(t,gt,e),p(b,t,e),n(t,Tt,e),p(N,t,e),n(t,$t,e),n(t,g,e),n(t,wt,e),n(t,H,e),n(t,Ct,e),n(t,_,e),n(t,xt,e),n(t,k,e),n(t,yt,e),p(S,t,e),n(t,Dt,e),n(t,T,e),n(t,Mt,e),n(t,P,e),n(t,Lt,e),n(t,R,e),n(t,bt,e),n(t,A,e),n(t,Nt,e),n(t,E,e),n(t,Ht,e),p(V,t,e),n(t,_t,e),n(t,$,e),n(t,kt,e),n(t,I,e),n(t,St,e),n(t,j,e),n(t,Pt,e),n(t,z,e),n(t,Rt,e),n(t,q,e),n(t,At,e),n(t,B,e),n(t,Et,e),p(G,t,e),n(t,Vt,e),n(t,O,e),n(t,It,e),p(U,t,e),n(t,jt,e),p(F,t,e),n(t,zt,e),n(t,w,e),n(t,qt,e),n(t,K,e),n(t,Bt,e),n(t,X,e),n(t,Gt,e),n(t,J,e),n(t,Ot,e),n(t,Q,e),n(t,Ut,e),p(W,t,e),n(t,Ft,e),n(t,C,e),n(t,Kt,e),n(t,Y,e),n(t,Xt,e),n(t,Z,e),n(t,Jt,e),n(t,tt,e),n(t,Qt,e),n(t,et,e),n(t,Wt,e),p(it,t,e),n(t,Yt,e),n(t,x,e),n(t,Zt,e),n(t,nt,e),n(t,te,e),n(t,st,e),n(t,ee,e),n(t,at,e),n(t,ie,e),n(t,lt,e),n(t,ne,e),n(t,rt,e),n(t,se,e),p(ot,t,e),n(t,ae,e),n(t,dt,e),n(t,le,e),p(mt,t,e),n(t,re,e),n(t,ut,e),oe=!0},p:Fe,i(t){oe||(u(D.$$.fragment,t),u(M.$$.fragment,t),u(b.$$.fragment,t),u(N.$$.fragment,t),u(S.$$.fragment,t),u(V.$$.fragment,t),u(G.$$.fragment,t),u(U.$$.fragment,t),u(F.$$.fragment,t),u(W.$$.fragment,t),u(it.$$.fragment,t),u(ot.$$.fragment,t),u(mt.$$.fragment,t),oe=!0)},o(t){f(D.$$.fragment,t),f(M.$$.fragment,t),f(b.$$.fragment,t),f(N.$$.fragment,t),f(S.$$.fragment,t),f(V.$$.fragment,t),f(G.$$.fragment,t),f(U.$$.fragment,t),f(F.$$.fragment,t),f(W.$$.fragment,t),f(it.$$.fragment,t),f(ot.$$.fragment,t),f(mt.$$.fragment,t),oe=!1},d(t){t&&(i(ft),i(pt),i(vt),i(ct),i(ht),i(L),i(gt),i(Tt),i($t),i(g),i(wt),i(H),i(Ct),i(_),i(xt),i(k),i(yt),i(Dt),i(T),i(Mt),i(P),i(Lt),i(R),i(bt),i(A),i(Nt),i(E),i(Ht),i(_t),i($),i(kt),i(I),i(St),i(j),i(Pt),i(z),i(Rt),i(q),i(At),i(B),i(Et),i(Vt),i(O),i(It),i(jt),i(zt),i(w),i(qt),i(K),i(Bt),i(X),i(Gt),i(J),i(Ot),i(Q),i(Ut),i(Ft),i(C),i(Kt),i(Y),i(Xt),i(Z),i(Jt),i(tt),i(Qt),i(et),i(Wt),i(Yt),i(x),i(Zt),i(nt),i(te),i(st),i(ee),i(at),i(ie),i(lt),i(ne),i(rt),i(se),i(ae),i(dt),i(le),i(re),i(ut)),i(h),v(D,t),v(M,t),v(b,t),v(N,t),v(S,t),v(V,t),v(G,t),v(U,t),v(F,t),v(W,t),v(it,t),v(ot,t),v(mt,t)}}}const ti='{"title":"CNN Based Video Models","local":"cnn-based-video-models","sections":[{"title":"General Trend:","local":"general-trend","sections":[],"depth":3}],"depth":1}';function ei(de){return Ke(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ai extends Xe{constructor(h){super(),Je(this,h,ei,Ze,Ue,{})}}export{ai as component};
